angular.module('myApp', ['ngTouch','ngAnimate'])

.controller("AppController", ['$scope', function($scope){
$scope.items=[{"name":"Apples","time":30},{"name":"Oranges","time":45},{"name":"Grapes","time":30},{"name":"Bananas","time":15},{"name":"Kiwi","time":5},{"name":"Watermelon","time":15},{"name":"Pear","time":10},{"name":"Avocado","time":45},{"name":"Mango","time":10},{"name":"Papaya","time":15},]

$scope.rangeOpts=[5,10,15,30,45];
$scope.rangeNum=45;

$scope.prepTimeFilter = function (location) {
return location.time <= $scope.rangeNum;
};

}])


.directive('ranger', function() {
return {
restrict: 'EA',
replace: true,
transclude: true,
scope: {
options: '=',
start: '=',
togpos:'@'
},
template: '<div class="dragdrop_slide"><button ng-repeat="prpt in options" ng-click="pos(prpt)"></button><button id="togslider" scrubber ng-class="\'tog\'+togpos"></button></div>',
link: function(scope, element, attrs) {
scope.pos=function(location){
scope.togpos=scope.options.indexOf(location);
scope.start=location;
}
}
};
})

.factory('$position', ['$document', '$window', function ($document, $window) {

    function getStyle(el, cssprop) {
      if (el.currentStyle) { //IE
        return el.currentStyle[cssprop];
      } else if ($window.getComputedStyle) {
        return $window.getComputedStyle(el)[cssprop];
      }
      // finally try and get inline style
      return el.style[cssprop];
    }

    /**
     * Checks if a given element is statically positioned
     * @param element - raw DOM element
     */
    function isStaticPositioned(element) {
      return (getStyle(element, "position") || 'static' ) === 'static';
    }

    /**
     * returns the closest, non-statically positioned parentOffset of a given element
     * @param element
     */
    var parentOffsetEl = function (element) {
      var docDomEl = $document[0];
      var offsetParent = element.offsetParent || docDomEl;
      while (offsetParent && offsetParent !== docDomEl && isStaticPositioned(offsetParent) ) {
        offsetParent = offsetParent.offsetParent;
      }
      return offsetParent || docDomEl;
    };

    return {
      /**
       * Provides read-only equivalent of jQuery's position function:
       * http://api.jquery.com/position/
       */
      position: function (element) {
        var elBCR = this.offset(element);
        var offsetParentBCR = { top: 0, left: 0 };
        var offsetParentEl = parentOffsetEl(element[0]);
        if (offsetParentEl != $document[0]) {
          offsetParentBCR = this.offset(angular.element(offsetParentEl));
          offsetParentBCR.top += offsetParentEl.clientTop - offsetParentEl.scrollTop;
          offsetParentBCR.left += offsetParentEl.clientLeft - offsetParentEl.scrollLeft;
        }

        var boundingClientRect = element[0].getBoundingClientRect();
        return {
          width: boundingClientRect.width || element.prop('offsetWidth'),
          height: boundingClientRect.height || element.prop('offsetHeight'),
          top: elBCR.top - offsetParentBCR.top,
          left: elBCR.left - offsetParentBCR.left
        };
      },

      /**
       * Provides read-only equivalent of jQuery's offset function:
       * http://api.jquery.com/offset/
       */
      offset: function (element) {
        var boundingClientRect = element[0].getBoundingClientRect();
        return {
          width: boundingClientRect.width || element.prop('offsetWidth'),
          height: boundingClientRect.height || element.prop('offsetHeight'),
          top: boundingClientRect.top + ($window.pageYOffset || $document[0].body.scrollTop || $document[0].documentElement.scrollTop),
          left: boundingClientRect.left + ($window.pageXOffset || $document[0].body.scrollLeft  || $document[0].documentElement.scrollLeft)
        };
      }
    };
  }])

.directive('scrubber', ['$document','$position', function($document,$position) {
return function(scope,element,attrs) {
var active=false;
var parentwidth;
var startX=0;
var startT=0;
var maxLeft;
var maxRight;
var offset;

start = function(e,a){
active=true;

if(a==1){
var touch = event.touches[0];
startX = touch.clientX;	
}else{
startX = e.clientX;
}

startT = $position.position(element).left

parentwidth=element.parent()[0].offsetWidth;
offset=parentwidth/5;
minLeft = (offset/2)-10;
maxRight = parentwidth-(offset/2)+5;

$document.bind('mouseup', function(e){end(e)});
$document.bind('mousemove', function(e){move(e,2)});
$document.bind('touchend', function(e){end(e)});
$document.bind('touchmove', function(e){move(e,1)});
}

move = function(e,a){
if(active){

if(a==1){
var touch = event.touches[0];
var newTop = parseInt(startT) + (touch.clientX - startX);
}else{
var newTop = parseInt(startT) + (e.clientX - startX);
}

if(newTop<minLeft){newTop=minLeft}
if(newTop>maxRight){newTop=maxRight}

element.css({left:newTop+'px'});

var perary=['0','.1','.3','.5','.7','.9'];
for (var i=0; i<6; i++){
var a=(parentwidth)*Number(perary[i]);
if(newTop<(a+15) && newTop > (a-15) ){
snapit(a,i-1);
}
}


}
}

snapit=function(a,i){
element.css({left:a+'px'});
scope.togpos=i;

scope.start=scope.options[i];


scope.$apply();
}

end = function(){
$document.unbind('touchmove', function(e){move(e)});
$document.unbind('mousemove', function(e){move(e)});
active=false;
element.css({left:""});

$document.unbind('touchend', function(e){end(e)});
$document.unbind('mouseup', function(e){end(e)});
}	

element.bind('touchstart', function(e){start(e,1)});
element.bind('mousedown', function(e){start(e,2)});
}
}]);

